<?php
/**
 * Created by PhpStorm.
 * User: aisrael
 * Date: 2019-04-18
 * Time: 19:23
 */

namespace Drupal\xtcdrupal\Plugin\XtcHandler;


abstract class EntityGetBase extends DrupalBase {

  /**
   * @var string
   */
  protected $entityType;

  protected function initProcess(){
    $this->entityType = $this->getEntityType();
  }

  protected function runProcess(){
    $this->content = $this->entityLoad();
  }

  protected function adaptContent(){
  }

  protected function entityLoad(){
    if(!empty($this->options['ids'])){
      return \Drupal::entityTypeManager()->getStorage($this->entityType)->loadMultiple(explode(',',$this->options['ids']));
    }

    $ids = \Drupal::entityQuery($this->entityType)->execute();
    return \Drupal::entityTypeManager()->getStorage($this->entityType)->loadMultiple($ids);
  }

  abstract protected function getEntityType();

}
