<?php
/**
 * Created by PhpStorm.
 * User: aisrael
 * Date: 2019-01-29
 * Time: 17:08
 */

namespace Drupal\xtcdrupal\XtendedContent\API;


use Drupal\xtc\XtendedContent\API\XtcExporterBase;
use Drupal\xtc\XtendedContent\API\XtcLoaderProfile;
use Drupal\xtc\XtendedContent\API\XtcWriterFile;

class XtcDrupalExporterFile extends XtcExporterBase {

  /**
   * @param $name
   * @param array $options
   *
   * @return mixed|null
   */
  protected static function load($name, $options = []) {
    $entity = $options['entity'] ?? 'node';
    $bundle = $options['bundle'] ?? '';
    $ids = $options['ids'] ?? '';
    if (!empty($ids)) {
      return XtcLoaderProfile::content($entity, ['ids' => $ids]);
    }
    if (!empty($bundle)) {
      return XtcLoaderProfile::content($entity, ['bundle' => $bundle]);
    }
    return XtcLoaderProfile::content($entity);
  }

  /**
   * @param $formatted
   *
   * @return \Symfony\Component\HttpFoundation\Response
   */
  protected static function save($formatted, $name, $options = []){
    $profile = XtcLoaderProfile::load($name);

    $entity = $options['entity'] ?? 'node';
    $bundle = $options['bundle'] ?? '';
    $ids = $options['ids'] ?? '';
    $ext = ($profile['filetype']) ? '.' . $profile['filetype'] : '';
    if (!empty($ids)) {
      $options = array_merge($options, ['filename' => $entity . '-several' . $ext]);
    }
    elseif (!empty($bundle)) {
      $options = array_merge($options, ['filename' => $entity . '-' . $bundle . $ext]);
    }
    else{
      $options = array_merge($options, ['filename' => $entity . '-all' . $ext]);
    }
    return XtcWriterFile::write($formatted, $name, $options);
  }

}
